package com.qmth.sop.business.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.qmth.sop.business.entity.TBDing;
import com.qmth.sop.business.entity.TBDingStatistic;

import java.util.List;

/**
 * <p>
 * 考勤提交统计表 服务类
 * </p>
 *
 * @author CaoZixuan
 * @since 2024-05-22
 */
public interface TBDingStatisticService extends IService<TBDingStatistic> {

    /**
     * 根据sopNo和用户档案id查询sop统计级路
     *
     * @param sopNo          sopNo
     * @param userArchivesId 用户档案id
     * @return 打卡统计记录
     */
    TBDingStatistic findBySopNoAndUserArchivesId(String sopNo, Long userArchivesId);

    /**
     * 构建考勤统计 (sop计划时间变更 -> 更新打卡统计时间)
     *
     * @param sopNo          sopNo
     * @param userArchivesId 用户档案id
     */
    void buildDingStatistic(String sopNo, Long userArchivesId);

    /**
     * 构建考勤统计 (sop计划时间变更 -> 更新打卡统计时间)
     *
     * @param sopNo sopNo
     */
    void buildDingStatistic(String sopNo);

    /**
     * 构建考勤统计 (构建打卡统计信息)
     */
    void buildDingStatistic();

    /**
     * 构建考勤统计 (构建打卡统计信息)
     *
     * @param sopNo         sopNo
     * @param datasource    数据源
     * @param requestUserId 创建人
     */
    void buildDingStatisticBySop(String sopNo, List<TBDing> datasource, Long requestUserId);
}
